from random import shuffle

def go(r, c, maze):
    directions = [ (-1,0), (1,0), (0,-1), (0,1) ]
    shuffle(directions)
    for dr, dc in directions:
        wr, wc, rr, rc = r+dr, c+dc, r+2*dr, c+2*dc
        if not (0 <= rr < len(maze) and 0 <= rc < len(maze[0])): continue
        if maze[rr][rc] == '.': continue
        maze[wr][wc] = '.'
        maze[rr][rc] = '.'
        go(rr, rc, maze)

def dfs_maze(R, C):
    maze = [ [ '#' for c in range(2*C+1) ] for r in range(2*R+1) ]
    for r in range(2*R+1):
        for c in range(2*C+1):
            if r % 2 and c % 2: maze[r][c] = '*'
    maze[1][1] = '.'
    go(1, 1, maze)
    return [ ''.join(row) for row in maze ]

if __name__ == '__main__':
    D = 10
    maze = dfs_maze(D, D)
    print(D)
    for row in maze: print(row)
