from random import shuffle

def mst_maze(R, C):
    maze = [ [ '#' for c in range(2*C+1) ] for r in range(2*R+1) ]
    color = [ [ None for c in range(2*C+1) ] for r in range(2*R+1) ]
    by_color = [ [] for n in range(R*C) ]
    
    N = 0
    for r in range(2*R+1):
        for c in range(2*C+1):
            if r % 2 and c % 2:
                maze[r][c] = '.'
                color[r][c] = N
                by_color[N].append( (r,c) )
                N += 1

    edges = [ (r,c) for r in range(1,2*R) for c in range(1,2*C) if r%2+c%2==1 ]
    shuffle(edges)

    for r,c in edges:
        if r%2 == 1: r0, c0, r1, c1 = r, c-1, r, c+1
        else:        r0, c0, r1, c1 = r-1, c, r+1, c

        col0, col1 = color[r0][c0], color[r1][c1]
        if col0 == col1: continue
        maze[r][c] = '.'

        if len( by_color[col1] ) > len( by_color[col0] ):
            col0, col1 = col1, col0
        for r, c in by_color[col1]:
            color[r][c] = col0
            by_color[col0].append( (r,c) )

    return [ ''.join(row) for row in maze ]

if __name__ == '__main__':
    D = 10
    maze = mst_maze(D, D)
    print(D)
    for row in maze: print(row)

